/*
Sensor to Web
Author : Benjamin Lemay
password: fabacademy
 */
#include <Bridge.h>
#include <BridgeServer.h>
#include <BridgeClient.h>
//#include <HttpClient.h>

// Pressure (FSR) sensor
byte sensor1 = A0;

// Listen on default port 5555, the webserver on the Yun
// will forward there all the HTTP requests for us.
BridgeServer server;

String startString;
String statusMessage = "ready";
String previousStatusMessage = "starting";

byte val = 0;



int measure(byte pin) {
  float Masse = 0;
  float fsrForce;
  float fsrReading;
  float fsrResistance;
  float fsrConductance;
  
  fsrReading = analogRead(pin);
  // analog voltage reading ranges from about 0 to 1023 which maps to 0V to 5V (= 5000mV)
  int fsrVoltage = map(fsrReading, 0, 1023, 0, 5000);
 
  if (fsrVoltage == 0) {
  } else {
    // The voltage = Vcc * R / (R + FSR) where R = 10K and Vcc = 5V
    // so FSR = ((Vcc - V) * R) / V        yay math!
    fsrResistance = 5000 - fsrVoltage;     // fsrVoltage is in millivolts so 5V = 5000mV
    fsrResistance *= 10000;                // 10K resistor
    fsrResistance /= fsrVoltage;
 
    fsrConductance = 1000000;           // we measure in micromhos so 
    fsrConductance /= fsrResistance;
 
    // Use the two FSR guide graphs to approximate the force
    if (fsrConductance <= 1000) {
      fsrForce = fsrConductance / 80;
      Masse = fsrForce * 1014.2 ;
      //Serial.println(Masse);    
    } else {
      fsrForce = fsrConductance - 1000;
      fsrForce /= 30;
      Masse = fsrForce * 1014.2 ;
      //Serial.println(Masse);
    }
  }
  //return Masse;
  return fsrReading;
}



void setup() {
  //Serial.begin(9600);

  Bridge.begin();
  
  Console.begin();
  //Serial.println("Starting Device...");
  
  //server.listenOnLocalhost();
  server.begin();
}

void loop() {
  // Get clients coming from server
  BridgeClient client = server.accept();
  if(client) { 
    String command = client.readStringUntil('/');
    readCommand(command, client);
    //runCommand();
    client.stop();
  }  
}


void readCommand(String command, BridgeClient client) {
   if (command == "status") {
    
    Console.print("reading analog values");
          
    val = measure(sensor1);

    client.println(String(val) + ";");

   }
   delay(50);
}
